// ignore_for_file: file_names, deprecated_member_use
import 'package:flutter/cupertino.dart';
import 'dart:ui' as ui;

import 'package:flutter/foundation.dart';

class UiImage extends ImageProvider<UiImage> {
  final ui.Image image;
  final double scale;

  const UiImage(this.image, {this.scale = 1.0});

  @override
  Future<UiImage> obtainKey(ImageConfiguration configuration) =>
      SynchronousFuture<UiImage>(this);

  @override
  ImageStreamCompleter load(UiImage key, Future<ui.Codec> Function(Uint8List, {bool allowUpscaling, int? cacheHeight, int? cacheWidth}) decode) =>
      OneFrameImageStreamCompleter(_loadAsync(key));

  Future<ImageInfo> _loadAsync(UiImage key) async {
    assert(key == this);
    return ImageInfo(image: image, scale: key.scale);
  }

  @override
  bool operator ==(dynamic other) {
    if (other.runtimeType != runtimeType) return false;
    final UiImage typedOther = other;
    return image == typedOther.image && scale == typedOther.scale;
  }

  @override
  int get hashCode => Object.hash(image.hashCode, scale);


  @override
  String toString() =>
      '$runtimeType(${describeIdentity(image)}, scale: $scale)';
}
